﻿using BalCoding.DurableDNSApi.DataAccess;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data;
using System;

namespace DurableDNSApiTest
{
    
    
    /// <summary>
    ///This is a test class for BalDnsRecordRepositoryTest and is intended
    ///to contain all BalDnsRecordRepositoryTest Unit Tests
    ///</summary>
	[TestClass()]
	public class BalDnsRecordRepositoryTest
	{

		private const string _sUser = "L2";
		private const string _sKey = "wG";

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for Update
		///</summary>
		[TestMethod()]
		public void UpdateTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "testbalhosting.net.";
			int lnRecordId = 8887345; //1276535969 - 1276535994
			DataTable loTable = BalDnsRecordRepository.Select(lsUser, lsKey, lsZone, lnRecordId);
			loTable.Rows[0][BalDnsRecordRepository.RecordMap.Data] = "6.3.2.1";
			BalDnsRecordRepository.Update(lsUser, lsKey, lsZone, lnRecordId, loTable);
		}

		/// <summary>
		///A test for Select
		///</summary>
		[TestMethod()]
		public void SelectTest1()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "balhosting.net.";
			DataTable actual;
			actual = BalDnsRecordRepository.Select(lsUser, lsKey, lsZone);
			foreach (DataColumn loColumn in actual.Columns)
			{
				Console.Write(loColumn.ColumnName + ",");
			}
			Console.WriteLine();
			foreach (DataRow loRow in actual.Rows)
			{
				foreach (DataColumn loColumn in actual.Columns)
				{
					Console.Write(loRow[loColumn.ColumnName] + ",");
				}
				Console.WriteLine();
			}
		}

		/// <summary>
		///A test for Select
		///</summary>
		[TestMethod()]
		public void SelectTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "balhosting.net.";
			int lnRecordId = 8724681; 
			DataTable actual;
			actual = BalDnsRecordRepository.Select(lsUser, lsKey, lsZone, lnRecordId);
			foreach (DataColumn loColumn in actual.Columns)
			{
				Console.Write(loColumn.ColumnName + ",");
			}
			Console.WriteLine();
			foreach (DataRow loRow in actual.Rows)
			{
				foreach (DataColumn loColumn in actual.Columns)
				{
					Console.Write(loRow[loColumn.ColumnName] + ",");
				}
				Console.WriteLine();
			}
		}

		/// <summary>
		///A test for Delete
		///</summary>
		[TestMethod()]
		public void DeleteTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "testbalhosting.net.";
			int lnRecordId = 8887345;
			BalDnsRecordRepository.Delete(lsUser, lsKey, lsZone, lnRecordId);
		}

		/// <summary>
		///A test for Insert
		///</summary>
		[TestMethod()]
		public void InsertTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "testbalhosting.net.";
			DataTable loTable = BalDnsRecordRepository.GetBlankTable();
			DataRow loRow = loTable.NewRow();
			loRow[BalDnsRecordRepository.RecordMap.Name] = "test";
			loRow[BalDnsRecordRepository.RecordMap.Type] = "A"; 
			loRow[BalDnsRecordRepository.RecordMap.Data] = "1.2.3.4";
			loRow[BalDnsRecordRepository.RecordMap.Aux] = 0;
			loRow[BalDnsRecordRepository.RecordMap.TTL] = 0;
			loRow[BalDnsRecordRepository.RecordMap.DDNS] = "N";
			loTable.Rows.Add(loRow);
			
			string[] actual;
			actual = BalDnsRecordRepository.Insert(lsUser, lsKey, lsZone, loTable);
			foreach (string lsId in actual)
			{
				Console.WriteLine(lsId);
			}
		}

		/// <summary>
		///A test for SelectIds
		///</summary>
		[TestMethod()]
		public void SelectIdsTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "balhosting.net.";
			int[] actual;
			actual = BalDnsRecordRepository.SelectIds(lsUser, lsKey, lsZone);
			foreach (int lnId in actual)
			{
				Console.WriteLine(lnId.ToString());
			}
		}
	}
}
