﻿using BalCoding.DurableDNSApi.DataAccess;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Data;
using System.IO;
using System;
using System.Collections.Generic;

namespace DurableDNSApiTest
{
    
    
    /// <summary>
    ///This is a test class for BalDnsZoneRepositoryTest and is intended
    ///to contain all BalDnsZoneRepositoryTest Unit Tests
    ///</summary>
	[TestClass()]
	public class BalDnsZoneRepositoryTest
	{
		private const string _sUser = "L2";
		private const string _sKey = "wG";

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion


		/// <summary>
		///A test for Update
		///</summary>
		[TestMethod()]
		public void UpdateTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "testbalhosting.net.";
			DataTable loTable = BalDnsZoneRepository.Select(_sUser, _sKey, lsZone);
			loTable.Rows[0][BalDnsZoneRepository.ZoneMap.Email] = "hostmastertest.balhosting.net.";
			BalDnsZoneRepository.Update(lsUser, lsKey, lsZone, loTable);
		}

		/// <summary>
		///A test for SelectNames
		///</summary>
		[TestMethod()]
		public void SelectNamesTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string[] actual;
			actual = BalDnsZoneRepository.SelectNames(lsUser, lsKey);
			foreach (string lsName in actual)
			{
				Console.WriteLine(lsName);
			}
		}

		/// <summary>
		///A test for Select
		///</summary>
		[TestMethod()]
		public void SelectTestZone()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "lakstins.com.";
			DataTable actual;
			actual = BalDnsZoneRepository.Select(lsUser, lsKey, lsZone);
			foreach (DataColumn loColumn in actual.Columns)
			{
				Console.Write(loColumn.ColumnName + ",");
			}
			Console.WriteLine();
			foreach (DataRow loRow in actual.Rows)
			{
				foreach (DataColumn loColumn in actual.Columns)
				{
					Console.Write(loRow[loColumn.ColumnName] + ",");
				}
				Console.WriteLine();
			}
		}

		/// <summary>
		///A test for Select
		///</summary>
		[TestMethod()]
		public void SelectTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			DataTable actual;
			actual = BalDnsZoneRepository.Select(lsUser, lsKey);
			foreach (DataColumn loColumn in actual.Columns)
			{
				Console.Write(loColumn.ColumnName + ",");
			}
			Console.WriteLine();
			foreach (DataRow loRow in actual.Rows)
			{
				foreach (DataColumn loColumn in actual.Columns)
				{
					Console.Write(loRow[loColumn.ColumnName] + ",");
				}
				Console.WriteLine();
			}
		}

		/// <summary>
		///A test for Insert
		///</summary>
		[TestMethod()]
		public void InsertTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "testbalhosting.net.";
			DataTable loTable = BalDnsZoneRepository.GetBlankTable();
			DataRow loRow = loTable.NewRow();
			loRow[BalDnsZoneRepository.ZoneMap.NameServer] = "ns1.balhosting.net.";
			loRow[BalDnsZoneRepository.ZoneMap.Email] = "hostmaster.balhosting.net.";
			loRow[BalDnsZoneRepository.ZoneMap.Xfer] = "";
			loRow[BalDnsZoneRepository.ZoneMap.UpdateACL] = "";
			loRow[BalDnsZoneRepository.ZoneMap.Serial] = 1;
			loRow[BalDnsZoneRepository.ZoneMap.Refresh] = 7200;
			loRow[BalDnsZoneRepository.ZoneMap.Retry] = 600;
			loRow[BalDnsZoneRepository.ZoneMap.Expire] = 1209600;
			loRow[BalDnsZoneRepository.ZoneMap.Minimum] = 3600;
			loRow[BalDnsZoneRepository.ZoneMap.TTL] = 1209600;
			loTable.Rows.Add(loRow);

			string[] actual;
			actual = BalDnsZoneRepository.Insert(lsUser, lsKey, lsZone, loTable);
			foreach (string lsName in actual)
			{
				Console.WriteLine(lsName);
			}
		}

		/// <summary>
		///A test for Delete
		///</summary>
		[TestMethod()]
		public void DeleteTest()
		{
			string lsUser = _sUser;
			string lsKey = _sKey;
			string lsZone = "testbalhosting.net.";
			BalDnsZoneRepository.Delete(lsUser, lsKey, lsZone);
		}

	}
}
